#! /usr/local/bin/perl
#############################################################################
#
#   Copyright 1995 by the Northeast Parallel Architectures Center at 
#   Syracuse University and Community School Networks, Inc..
#  
#   File: register.pl
#
#   Author:   Paul Coddington (paulc@npac.syr.edu)
#
#   Created:  11/21/95
#   Version:  0.1
#
#   Output: Make new password file and database of registered users 
#           Display appropriate page to the user
#
#############################################################################

require "source/ParseArg.pl";		# parses the passed arguments
require "source/Address.pl";		# sets global variables

%in = ();
&ParseArg(*in);			# parse arguments passed by http server
$subdir = $in{'page'};
&NewPasswdFile();
&NewDataFile();
&NextPage();
# &Address();


# Append information to a new password file

sub NewPasswdFile{

   if ($subdir) {
      open(OUTFILE, ">>$subdir/passwd.new") ||
         print "Content-type\: text/html\n\n 
                Cannot open new password file for $subdir\: $!";
   }
   else {
      print "Content-type\: text/html\n\n 
             Cannot open directory $subdir\: $!";
   }
   print OUTFILE "$in{'firstname'} $in{'lastname'}\:$in{'password'}\:$in{'email'}\n";
   close(OUTFILE);
   # chmod 400, "$subdir/$passwd.new";
}
1;


# Append information to a new database file

sub NewDataFile{

   if ($subdir) {
      open(OUTFILE, ">>$subdir/database.new") ||
         print "Content-type\: text/html\n\n 
                Cannot open new database file for $subdir\: $!";
   }
   else {
      print "Content-type\: text/html\n\n 
             Cannot open directory $subdir\: $!";
   }
   print OUTFILE "\n";
   print OUTFILE "firstname \: $in{'firstname'}\n";
   print OUTFILE "lastname \: $in{'lastname'}\n";
   print OUTFILE "email \: $in{'email'}\n";
   print OUTFILE "password \: $in{'password'}\n";
   print OUTFILE "schoolname \: $in{'schoolname'}\n";
   print OUTFILE "schooladd1 \: $in{'schooladd1'}\n";
   print OUTFILE "schooladd2 \: $in{'schooladd2'}\n";
   print OUTFILE "areacode \: $in{'areacode'}\n";
   print OUTFILE "phone \: $in{'phone'}\n";
   print OUTFILE "fax \: $in{'fax'}\n";
   close(OUTFILE);
   # chmod 400, "$subdir/$database.new";
}
1;


# THIS NEEDS TO BE DONE!!
# Use this to check that name doesn't already exist in the database 
# (i.e. name and email are new)

sub CheckName{
   local($subdir, $uid) = @_;
   local($userid, $upass, $name, $email);

   if ($subdir) {
      open(INFILE, "$subdir/$checkfile") ||
      print "Content-type\: text/html\n\n Cannot open $subdir/$checkfile\: $!";
   }
   else {
      open(INFILE, "$checkfile");
   }

   while(<INFILE>) {
	($userid, $upass, $name, $email) = split(/\:/, $_);
	if($userid eq $uid) {
	    $_ = $name.":".$email;
	    s/ /+/g;
	    return $_;
	}
   }
   close(INFILE);
   "0";
}
1;


sub NextPage{
    print "Content-type\: text/html\n\n";
    $filename = $in{'filename'};
    open(INFILE, "< $filename") ||
      print "Cannot open $filename\: $!";
    while(<INFILE>) {
      print;
    }
    close(INFILE);
}
1;

